using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace IndexLogic
{
    public class IPTextBox : TextBox
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public IPTextBox()
        {
            // Install an event
            this.TextChanged += new EventHandler(IPTextBox_TextChanged);
        }

        /// <summary>
        /// Event handler: occurs when the text is changed
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void IPTextBox_TextChanged(object sender, EventArgs e)
        {
            if (this.Valid == false)
                this.BackColor = Color.OrangeRed;
            else
                this.BackColor = Color.LightGreen;
        }

        /// <summary>
        /// true: IP address is valid
        /// false: IP address is not valid
        /// </summary>
        public bool Valid
        {
            get
            {
                string[] quads = this.Text.Split('.');
                if (!(quads.Length == 4)) return false;
                foreach (string quad in quads)
                {
                    int q = 0;
                    if (!Int32.TryParse(quad, out q)) return false;
                    if ((q < 0) || (q > 255)) return false;
                }
                return true;
            }
        }
    }
}
